import { ObserveBaseDirective } from './observe-base.directive';
import { ResolvedObserveContext } from './types/general';
import { ObservableArray } from './types/arrays';
import * as i0 from "@angular/core";
/**
 * The base class for `*observe` directives combining observables using an array of observable values (i.e. [x$, y$]).
 *
 * @export
 * @abstract
 * @class ObserveArrayDirective
 * @extends {ObserveBaseDirective<TInput, TResolved, TContext>}
 * @template TInput The type of observable array.
 * @template TResolved The type of resolved array.
 * @template TContext The the of context the directive will provide to the view.
 */
export declare abstract class ObserveArrayDirective<TInput extends ObservableArray, TResolved, TContext extends ResolvedObserveContext<TResolved> = ResolvedObserveContext<TResolved>> extends ObserveBaseDirective<TInput, TResolved, TContext> {
    static ɵfac: i0.ɵɵFactoryDeclaration<ObserveArrayDirective<any, any, any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ObserveArrayDirective<any, any, any>, never, never, {}, {}, never, never, false>;
}
