export declare class MockElement {
    tagName?: string | undefined;
    parentElement?: MockElement;
    children: any[];
    dir?: 'ltr' | 'rtl';
    className?: string;
    constructor(tagName?: string | undefined);
    remove(): void;
    removeChild(node: any): void;
    appendChild(node: any): void;
    querySelectorAll(selector: string): any[];
    /**
     * Extracts an array of {name, value} objects mapping the attributes from the specified selector string.
     * Attributes with no value will be mapped with wildcard value (i.e. '**').
     *
     * @param {string} selector
     * @returns {*}
     */
    extractAttributesFromSelector(selector: string): any;
}
