import { ModuleWithProviders } from '@angular/core';
import { LanguageIntegrationProvider } from './config/language-integration.provider';
import * as i0 from "@angular/core";
import * as i1 from "@bespunky/angular-zen/core";
/**
 * Provides services for libraries requiring integration with their user's language services.
 *
 * @export
 * @class LanguageIntegrationModule
 */
export declare class LanguageIntegrationModule {
    constructor(parentModule: LanguageIntegrationModule);
    /**
     * Generates the language integration modules with the appropriate providers for the app to share its language services with
     * libraries and supporting languages.
     *
     * @static
     * @param {LanguageIntegrationProvider} configProvider The integration configuration. Tells the module how to operate with your language services.
     */
    static forRoot(configProvider: LanguageIntegrationProvider): ModuleWithProviders<LanguageIntegrationModule>;
    static ɵfac: i0.ɵɵFactoryDeclaration<LanguageIntegrationModule, [{ optional: true; skipSelf: true; }]>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<LanguageIntegrationModule, never, [typeof i1.CoreModule], never>;
    static ɵinj: i0.ɵɵInjectorDeclaration<LanguageIntegrationModule>;
}
