import { UrlLocalizer } from './url-localizer';
import * as i0 from "@angular/core";
/**
 * A noop implemetation for the `UrlLocalizer` class.
 * Always returns unchanged urls.
 *
 * @export
 * @class NoopUrlLocalizer
 * @extends {UrlLocalizer}
 */
export declare class NoopUrlLocalizer extends UrlLocalizer {
    /**
     * Returns the currently navigated url as is.
     *
     * @param {string} lang Ignore.
     * @returns {string} The currently navigated url as is.
     */
    localize(lang: string): string;
    /**
     * Returns the currently navigated url as is.
     *
     * @returns {string} The currently navigated url as is.
     */
    delocalize(): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<NoopUrlLocalizer, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<NoopUrlLocalizer>;
}
