import { ModuleWithProviders } from '@angular/core';
import { RouterXConfig } from './config/router-x-config';
import * as i0 from "@angular/core";
import * as i1 from "./outlet/publish-component.directive";
import * as i2 from "@bespunky/angular-zen/core";
/**
 * Provides services for libraries requiring integration with their user's language services.
 *
 * @export
 * @class RouterXModule
 */
export declare class RouterXModule {
    constructor(parentModule: RouterXModule);
    /**
     * Generates the router-x module with the appropriate providers.
     *
     * @static
     * @param {RouterXConfig} config (Optional) The configuration for the router extension module.
     */
    static forRoot(config?: RouterXConfig): ModuleWithProviders<RouterXModule>;
    /**
     * Generates the router-x module for child modules.
     *
     * @static
     */
    static forChild(): ModuleWithProviders<RouterXModule>;
    static ɵfac: i0.ɵɵFactoryDeclaration<RouterXModule, [{ optional: true; skipSelf: true; }]>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<RouterXModule, [typeof i1.PublishComponentDirective], [typeof i2.CoreModule], [typeof i1.PublishComponentDirective]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<RouterXModule>;
}
