import { Route } from '@angular/router';
import * as i0 from "@angular/core";
/**
 * Recoursively creates nested routes for the specified segments.
 * Each specified segment will be a child route of its previous segment.
 *
 * #### Example
 * Running the function on `['some', 'route']` will result in the following supported routes:
 * /
 *
 * /some
 * /some/route
 *
 * @export
 * @param {string[]} segments The route segments from which routes are to be created.
 * @returns {Route} An Angular router module compatible route tree containing all segments as child routes.
 */
export declare function createDeeplyNestedRoutes(segments: string[]): Route;
/**
 * A functionless component.
 * Can be used for setting routes in which the component is not important, but required by the route object.
 *
 * @export
 * @class NoopComponent
 */
export declare class NoopComponent {
    static ɵfac: i0.ɵɵFactoryDeclaration<NoopComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NoopComponent, "zen-router-x-noop", never, {}, {}, never, never, false>;
}
/**
 * A functionless module exporting the functionless `NoopComponent`.
 *
 * @export
 * @class NoopModule
 */
export declare class NoopModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<NoopModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<NoopModule, [typeof NoopComponent], never, [typeof NoopComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<NoopModule>;
}
