import { Observable } from 'rxjs';
import { Type } from '@angular/core';
import { RouterEvent } from '@angular/router';
/**
 * Creates an observable which emits only the specified routing event.
 *
 * @export
 * @template T The type of router event to observe.
 * @param {Type<T>} eventType The type of router event to observe.
 * @return {Observable<T>} An observable which emits only the specified routing event.
 */
export declare function useRouterEvent<T extends RouterEvent>(eventType: Type<T>): Observable<T>;
