import { Observable } from 'rxjs';
import { Type } from '@angular/core';
import { RouterEvent } from '@angular/router';
declare type TypeInstance<T extends Type<any>> = T extends Type<infer Instance> ? Instance : never;
/**
 * Creates an observable which emits only the specified router events.
 *
 * @export
 * @param {readonly [...Events]} eventTypes
 * @template Events The types of events to observe.
 * @returns {Observable<TypeInstance<Events[number]>>} An observable which emits only the specified router events.
 */
export declare function useRouterEvents<Events extends readonly Type<RouterEvent>[]>(...eventTypes: readonly [...Events]): Observable<TypeInstance<Events[number]>>;
export {};
